Global = {}

_sciteHome = props['SciteDefaultHome']

local s,e = string.find(_sciteHome,'\\',0,true)
local s,e = string.find(_sciteHome,'\\',e+1,true)
local _boxHome = string.sub(_sciteHome,0,s)

function Global.GetBoxHome()
	return _boxHome;
end

function Global.CurrentWord()
  local p = editor.CurrentPos
  local s = editor:WordStartPosition(p,true)
  local e = editor:WordEndPosition(p,true)
  editor:SetSel(s,e)
  return editor:GetSelText()
end

function Global.CharAt(n)
	return string.char(math.abs(editor.CharAt[n]))
end

function Global.Trim(s)
  return (string.gsub(s, "^%s*(.-)%s*$", "%1"))
end

--[[
function dofile (filename)
  local f = assert(loadfile(filename))
  return f()
end
]]--

local _which = 10
function Global.AddCommand(name, funcName, savebefore, shortcut, ext, subsystem)
	props['command.name.'.._which..ext] = name;
    props['command.'.._which..ext] = funcName;
    props['command.subsystem.'.._which..ext] = subsystem;
	props['command.mode.'.._which..ext] = 'savebefore:'..savebefore;
    props['command.shortcut.'.._which..ext] = shortcut;
	_which = _which+1;
end

function Global.GetLexerName()
	local lexers = {
		[SCLEX_CONTAINER] = "text",
		[SCLEX_NULL] = "null",
		[SCLEX_PYTHON] = "python",
		[SCLEX_CPP] = "cpp",
		[SCLEX_HTML] = "hypertext",
		[SCLEX_XML] = "xml",
		[SCLEX_PERL] = "perl",
		[SCLEX_SQL] = "sql",
		[SCLEX_VB] = "vb",
		[SCLEX_PROPERTIES] = "props",
		[SCLEX_ERRORLIST] = "errorlist",
		[SCLEX_MAKEFILE] = "makefile",
		[SCLEX_BATCH] = "batch",
		[SCLEX_XCODE] = "xcode",
		[SCLEX_LATEX] = "latex",
		[SCLEX_LUA] = "lua",
		[SCLEX_DIFF] = "diff",
		[SCLEX_CONF] = "conf",
		[SCLEX_PASCAL] = "pascal",
		[SCLEX_AVE] = "ave",
		[SCLEX_ADA] = "ada",
		[SCLEX_LISP] = "lisp",
		[SCLEX_RUBY] = "ruby",
		[SCLEX_EIFFEL] = "eiffel",
		[SCLEX_EIFFELKW] = "eiffelkw",
		[SCLEX_TCL] = "tcl",
		[SCLEX_NNCRONTAB] = "nncrontab",
		[SCLEX_BULLANT] = "bullant",
		[SCLEX_VBSCRIPT] = "vbscript",
-- 		[SCLEX_ASP] = "asp", --SCLEX_ASP and SCLEX_PHP should not be used in new code: use SCLEX_HTML instead
-- 		[SCLEX_PHP] = "php",
		[SCLEX_BAAN] = "baan",
		[SCLEX_MATLAB] = "matlab",
		[SCLEX_SCRIPTOL] = "scriptol",
		[SCLEX_ASM] = "asm",
		[SCLEX_CPPNOCASE] = "cppnocase",
		[SCLEX_FORTRAN] = "fortran",
		[SCLEX_F77] = "f77",
		[SCLEX_CSS] = "css",
		[SCLEX_POV] = "pov",
		[SCLEX_LOUT] = "lout",
		[SCLEX_ESCRIPT] = "escript",
		[SCLEX_PS] = "ps",
		[SCLEX_NSIS] = "nsis",
		[SCLEX_MMIXAL] = "mmixal",
		[SCLEX_CLW] = "clarion",
		[SCLEX_CLWNOCASE] = "clarionnocase",
		[SCLEX_LOT] = "lot",
		[SCLEX_YAML] = "yaml",
		[SCLEX_TEX] = "tex",
		[SCLEX_METAPOST] = "metapost",
		[SCLEX_POWERBASIC] = "powerbasic",
		[SCLEX_FORTH] = "forth",
		[SCLEX_ERLANG] = "erlang",
		[SCLEX_OCTAVE] = "octave",
		[SCLEX_MSSQL] = "mssql",
		[SCLEX_VERILOG] = "verilog",
		[SCLEX_KIX] = "kix",
		[SCLEX_GUI4CLI] = "gui4cli",
		[SCLEX_SPECMAN] = "specman",
		[SCLEX_AU3] = "au3",
		[SCLEX_APDL] = "apdl",
		[SCLEX_BASH] = "bash",
		[SCLEX_ASN1] = "asn1",
		[SCLEX_VHDL] = "vhdl",
		[SCLEX_CAML] = "caml",
		[SCLEX_BLITZBASIC] = "blitzbasic",
		[SCLEX_PUREBASIC] = "purebasic",
		[SCLEX_HASKELL] = "haskell",
		[SCLEX_PHPSCRIPT] = "phpscript",
		[SCLEX_TADS3] = "tads3",
		[SCLEX_REBOL] = "rebol",
		[SCLEX_SMALLTALK] = "smalltalk",
		[SCLEX_FLAGSHIP] = "flagship",
		[SCLEX_CSOUND] = "csound",
		[SCLEX_FREEBASIC] = "freebasic",
		[SCLEX_INNOSETUP] = "inno",
		[SCLEX_OPAL] = "opal",
		[SCLEX_SPICE] = "spice",
		[SCLEX_CLOJURE] = "clojure",
	}
	return lexers[editor.Lexer]
end
