require("gui");

props["STR_ENTER"] = "\r\n"

_sciteHome = props['SciteDefaultHome']

local s,e = string.find(_sciteHome,'\\',0,true)
local s,e = string.find(_sciteHome,'\\',e+1,true)
local _boxHome = string.sub(_sciteHome,0,s)

dofile (_sciteHome..'\\tools\\init_extman.lua')
dofile (_sciteHome..'\\tools\\init_global_functions.lua')
dofile (_sciteHome..'\\tools\\init_lua_scite_other.lua')
dofile (_sciteHome..'\\tools\\init_editing.lua')
dofile (_sciteHome..'\\tools\\init_filemanager.lua')
dofile (_sciteHome..'\\tools\\init_events.lua')
dofile (_sciteHome..'\\tools\\init_switch_buffers.lua')
dofile (_sciteHome..'\\tools\\init_todolist.lua')

--GLOBAL COMMANDS
--Ctrl+Alt+D
Global.AddCommand('Delete actual line','dostring editor:LineDelete()','no','Ctrl+Alt+D','.*','3')
--Ctrl+Alt+S
Global.AddCommand('Get selection size','dofile $(SciteDefaultHome)\\tools\\selection_size.lua','no','Ctrl+Alt+S','.*','3')
--Ctrl+Alt+G
Global.AddCommand('Go Google','dofile $(SciteDefaultHome)\\tools\\google_search.lua','no','Ctrl+Alt+G','.*','3');
--Ctrl+Alt+A
Global.AddCommand('Print selection ASCII values', 'dofile $(SciteDefaultHome)\\tools\\to_ascii.lua','no','Ctrl+Alt+A','.*','3')
--Ctrl+Alt+R
Global.AddCommand('Run selection as Lua','dostring dostring("$(CurrentSelection)")','no','Ctrl+Alt+R','.*','3')
--Ctrl+Shift+S
Global.AddCommand('Sort Text','dofile $(SciteDefaultHome)\\tools\\sort_text.lua','no','Ctrl+Shift+S','.*','3')
--Ctrl+Shift+R
Global.AddCommand('Remove Duplicate','dofile $(SciteDefaultHome)\\tools\\rem_duplicates.lua','no','Ctrl+Shift+R','.*','3')
--Ctrl-Alt-F
Global.AddCommand('List all Occurrences','dofile $(SciteDefaultHome)\\tools\\list_all_occurrences.lua','no','Ctrl+Alt+F','.*','3')
--Ctrl+Alt+P
Global.AddCommand('Insert a copy of the Bookmarked line(s)','dofile $(SciteDefaultHome)\\tools\\insert_bookmark_copy.lua','no','Ctrl+Alt+P','.*','3')
--Alt+Right
Global.AddCommand('Rightwards','dofile $(SciteDefaultHome)\\tools\\moveright.lua','no','Alt+Right','.*','3')
--Alt+Left
Global.AddCommand('Leftwards','dofile $(SciteDefaultHome)\\tools\\moveleft.lua','no','Alt+Left','.*','3')
--Alt+Up
Global.AddCommand('Upwards','dofile $(SciteDefaultHome)\\tools\\moveup.lua','no','Alt+Up','.*','3')
--Alt+Down
Global.AddCommand('Downwards','dofile $(SciteDefaultHome)\\tools\\movedown.lua','no','Alt+Down','.*','3')
--Ctrl+Shift+X
Global.AddCommand('Smart cut','dostring Editing.Smart_CutCopy(\'cut\')','no','Ctrl+Shift+X','.*','3')
--Ctrl+Shift+C
Global.AddCommand('Smart copy','dostring Editing.Smart_CutCopy(\'copy\')','no','Ctrl+Shift+C','.*','3')
--Ctrl+Shift+V
Global.AddCommand('Smart paste','dostring Editing.Smart_Paste(\'cycle\')','no','Ctrl+Shift+V','.*','3')
--Ctrl+K
Global.AddCommand('Switch Buffer','do_buffer_list','no','Ctrl+K','.*','3')
--Ctrl+J
Global.AddCommand('Todo List','EnableTodo','no','Ctrl+J','.*','3')

--------------------------
-------------LISP COMMANDS
Global.AddCommand('_________LISP COMMANDS_________','','no','','.$(file.patterns.lisp)','3')
--Alt+(
Global.AddCommand('Enclose','dostring Editing.Enclose(\'parens\')','no','Alt+(','.$(file.patterns.lisp)','3')
--Ctrl+B
Global.AddCommand('Select enclosing form','dostring Lisp.SelectBetweenPairs()','no','Ctrl+B','.$(file.patterns.lisp)','3')
--Ctrl+Alt+Right
Global.AddCommand('Goto right parenthesis','dostring Lisp.GotoEnclosure()','no','Ctrl+Alt+Right','.$(file.patterns.lisp)','3')
--Ctrl+Alt+Left
Global.AddCommand('Goto left parenthesis','dostring Lisp.GotoEnclosure()','no','Ctrl+Alt+Left','.$(file.patterns.lisp)','3')

props['command.help.$(file.patterns.lisp)'] = '$(CurrentWord)!'..Global.GetBoxHome()..'docs\\clhs\\clhs.chm';
props['command.help.subsystem.$(file.patterns.lisp)'] = 4;

props['command.1.$(file.patterns.lisp)'] = '$(CurrentWord)!'..Global.GetBoxHome()..'docs\\cltl2\\CLtL2.chm';
props['command.subsystem.1.$(file.patterns.lisp)'] = 4;
props['command.name.1.$(file.patterns.lisp)'] = 'CLtL2 (chm)';
props['command.mode.1.$(file.patterns.lisp)'] = 'savebefore:no';

props['command.2.$(file.patterns.lisp)'] = Global.GetBoxHome()..'docs\\clhs\\front\\index.htm';
props['command.subsystem.2.$(file.patterns.lisp)'] = 2;
props['command.name.2.$(file.patterns.lisp)'] = 'CLHS (html)';
props['command.mode.2.$(file.patterns.lisp)'] = 'savebefore:no';

props['command.8.$(file.patterns.lisp)'] = Global.GetBoxHome()..'bin\\corman.bat';
props['command.subsystem.8.$(file.patterns.lisp)'] = 2;
props['command.name.8.$(file.patterns.lisp)'] = 'Corman Lisp';
props['command.mode.8.$(file.patterns.lisp)'] = 'savebefore:no';

props['command.9.$(file.patterns.lisp)'] = Global.GetBoxHome()..'bin\\winclisp.exe';
props['command.subsystem.9.$(file.patterns.lisp)'] = 1;
props['command.name.9.$(file.patterns.lisp)'] = 'WinCLisp';
props['command.mode.9.$(file.patterns.lisp)'] = 'savebefore:no';

props['command.0.$(file.patterns.lisp)'] = Global.GetBoxHome()..'bin\\clisp.bat';
props['command.subsystem.0.$(file.patterns.lisp)'] = 1;
props['command.name.0.$(file.patterns.lisp)'] = 'CLisp (DOS)';
props['command.mode.0.$(file.patterns.lisp)'] = 'savebefore:no';

--~ --------------------------
--~ -------------CLOJURE COMMANDS
Global.AddCommand('_________CLOJURE COMMANDS_________','','no','','.$(file.patterns.clj)','3')
--Alt+(
Global.AddCommand('Enclose','dostring Editing.Enclose(\'parens\')','no','Alt+(','.$(file.patterns.clj)','3')
--Ctrl+B
Global.AddCommand('Select enclosing form','dostring Lisp.SelectBetweenPairs()','no','Ctrl+B','.$(file.patterns.clj)','3')
--Ctrl+Alt+Right
Global.AddCommand('Goto right parenthesis','dostring Lisp.GotoEnclosure(\'right\')','no','Ctrl+Alt+Right','.$(file.patterns.clj)','3')
--Ctrl+Alt+Left
Global.AddCommand('Goto left parenthesis','dostring Lisp.GotoEnclosure(\'left\')','no','Ctrl+Alt+Left','.$(file.patterns.clj)','3')
--Ctrl+Alt+E
Global.AddCommand('Evaluate expression','dostring Lisp.SendCommand()','no','Ctrl+Alt+E','.$(file.patterns.clj)','3')

props['command.help.$(file.patterns.clj)'] = props['ACB_HOME']..'\\usr\\doc\\clj-doc\\index.html';
props['command.help.subsystem.$(file.patterns.clj)'] = 2;

props['command.go.$(file.patterns.clj)'] = 'dostring Lisp.SendCommand()';
props['command.go.subsystem.$(file.patterns.clj)'] = 3;

props['command.0.$(file.patterns.clj)'] = props['ACB_HOME']..'\\bin\\clj.bat';
props['command.subsystem.0.$(file.patterns.clj)'] = 0;
props['command.name.0.$(file.patterns.clj)'] = 'Clojure (DOS)';
props['command.mode.0.$(file.patterns.clj)'] = 'savebefore:no';

props['command.1.$(file.patterns.clj)'] = 'java -cp '..props['ACB_HOME']..'\\usr\\bin\\clojure\\clojure.jar;'..props['ACB_HOME']..'\\usr\\lib\\clojure-contrib\\clojure-contrib.jar clojure.main '..props['ACB_HOME']..'\\usr\\src\\eval-str.clj "(doc $(CurrentWord))"';
props['command.subsystem.1.$(file.patterns.clj)'] = 0;
props['command.name.1.$(file.patterns.clj)'] = 'Show documentation';
props['command.mode.1.$(file.patterns.clj)'] = 'savebefore:no';

props['command.2.$(file.patterns.clj)'] = 'java -cp '..props['ACB_HOME']..'\\usr\\bin\\clojure\\clojure.jar;'..props['ACB_HOME']..'\\usr\\lib\\clojure-contrib\\clojure-contrib.jar clojure.main '..props['ACB_HOME']..'\\usr\\src\\eval-str.clj "(source $(CurrentWord))"';
props['command.subsystem.2.$(file.patterns.clj)'] = 0;
props['command.name.2.$(file.patterns.clj)'] = 'Show source';
props['command.mode.2.$(file.patterns.clj)'] = 'savebefore:no';
