--Depends on init_editing.lua

Lisp = {}

editor.AutoCTypeSeparator=string.byte("~")

-- BEGIN EDITING LISP TOOLS
function Lisp.SendCommand(sendCommandPath)
	local command = editor:GetSelText();

	if string.len(command) == 0 then
		command = editor:GetText()
	end

	local f = io.open(props['ACB_HOME']..'\\bin\\scite\\tools\\SendCommand\\~SendCommand.tmp','w')
	command = string.gsub(command,'\r','')
	f:write(command)
	f:flush()
	f:close()

	Execute(props['ACB_HOME']..'\\bin\\scite\\tools\\SendCommand\\SendCommand.exe');
end

function Lisp.SelectBetweenPairs()
 	local ss,ee = editor:findtext(editor:GetSelText(),SCFIND_MATCHCASE,0)

	local s, e = GetCoordsBetweenStrings()

	if (s ~= -666 and e ~= -666) then
		editor:SetSel(s, e+1)
	else
		editor:SetSel(ss,ee)
	end
end

function Lisp.GotoEnclosure(direction)

	local s, e = GetCoordsBetweenStrings()

	if(direction == 'right') then
		editor:GotoPos(e+1)
	else
		editor:GotoPos(s)
	end
end

function GetCoordsBetweenStrings()
	local currPos = editor.CurrentPos

	local s, str = SearchBackward()
	editor:GotoPos(currPos)
	local e = SearchForeword(str)

 	return s, e
end

function SearchBackward()
	local currPos = editor.CurrentPos - 1
	local level = 0
	local e = -1
	local open = ''
	local close = ''

	local currPosLimit = -1

	while e == -1 do
		local lSub = Global.CharAt(currPos)
		if (revenclosure[lSub] ~= nil) then

			open = enclosure[revenclosure[lSub]].left
			close = enclosure[revenclosure[lSub]].right;

			if (open == lSub) then
				if (level == 0) then
					e = currPos
				else
					level = level - 1
				end
			elseif (close == lSub) then
				level = level + 1
			end
		end

		if (currPos == currPosLimit) then
			return -666
		end

		-- FOR DEBUG
		--print ('Dir:'..direction..' Level: '..level..' in char '..CharAt(currPos)..' at position '..currPos)

		currPos = currPos - 1
	end

	return e, revenclosure[open]
end

function SearchForeword(str)
	if (str == '' or str == nil) then
		return -666;
	end

	local currPos = editor.CurrentPos
	local level = 0
	local e = -1

	local dirOffset = 1
	local levelDownChar = enclosure[str].right
	local levelUpChar = enclosure[str].left
	local currPosLimit = editor.TextLength

	while e == -1 do
		if (Global.CharAt(currPos) == levelDownChar) then
			if (level == 0) then
				e = currPos
			else
				level = level - 1
			end
		elseif (Global.CharAt(currPos) == levelUpChar) then
			level = level + 1
		end

		if (currPos == currPosLimit) then
			return -666
		end

		-- FOR DEBUG
		--print ('Dir:'..direction..' Level: '..level..' in char '..CharAt(currPos)..' at position '..currPos)

		currPos = currPos + dirOffset
	end

	return e
end
